-- pakiet i2x_Pars - tresc

with Ada.Text_IO; use Ada.Text_IO; -- <- kod uzytkownika
with Ini2Xml_Wy; use Ini2Xml_Wy; -- <- kod uzytkownika

with i2x_Skan; use i2x_Skan;
with i2x_zbiory;use i2x_zbiory;

package body i2x_Pars is

Tok: Token_Typ;

procedure Parsuj is
begin
  Init_Zbiory;
  Put_Line("** Poczatek"); -- <- kod uzytkownika
  Otworz_Plik_We("a.ini"); -- <- kod uzytkownika
  Otworz_Plik_Wy("a.xml"); -- <- kod uzytkownika
  Pisz_Plik_Wy("<?xml version=""1.0""?>"); -- <- kod uzytkownika
  Tok := Skanuj;
  Plik;
  Zamknij_Plik_Wy;
  Zamknij_Plik_We;
  Put_Line("** Koniec"); -- <- kod uzytkownika
exception
  when Blad_Skanera =>put_Line("Blad skanera:"&Integer'Image(Nr_Bledu_Skan)&" l:"&Integer'Image(Nr_Linii)); -- <- kod uzytkownika
  when Blad_Parsera =>put_Line("Blad parsera:"&Integer'Image(Nr_Bledu_Pars)&" l:"&Integer'Image(Nr_Linii)); -- <- kod uzytkownika
end Parsuj;

procedure Plik is
begin
  Pisz_Plik_Wy("<plik_ini>"); -- <- kod uzytkownika
  Sekcja;
  loop
    if not (Zawiera_Sie(Tok.Kod,First_Sekcja)) then exit;
    end if;
    Sekcja;
  end loop;
  Pisz_Plik_Wy("</plik_ini>"); -- <- kod uzytkownika
end Plik;

procedure Sekcja is
begin
  if Tok.Kod=LewyNawiasKw then
    -- tu wpisz obsluge tokena 'LewyNawiasKw'
    null;
    Tok:=Skanuj;
  else Nr_Bledu_Pars:=11; raise Blad_Parsera;
  end if;
  if Tok.Kod=Nazwa then
    -- wstawiony kod 
    Pisz_Plik_Wy("<sekcja nazwa="""&US(Tok.Wart)&""" >");
    -- koniec kodu 
    -- tu wpisz obsluge tokena 'Nazwa'
    null;
    Tok:=Skanuj;
  else Nr_Bledu_Pars:=12; raise Blad_Parsera;
  end if;
  if Tok.Kod=PrawyNawiasKw then
    -- tu wpisz obsluge tokena 'PrawyNawiasKw'
    null;
    Tok:=Skanuj;
  else Nr_Bledu_Pars:=13; raise Blad_Parsera;
  end if;
  Element;
  loop
    if not (Zawiera_Sie(Tok.Kod,First_Element)) then exit;
    end if;
    Element;
  end loop;
  Pisz_Plik_Wy("</sekcja>"); -- <- kod uzytkownika
end Sekcja;

procedure Element is
begin
  if Tok.Kod=Nazwa then
    -- wstawiony kod 
    Pisz_Plik_Wy("<element nazwa="""&US(Tok.Wart)&""">");
    -- koniec kodu 
    -- tu wpisz obsluge tokena 'Nazwa'
    null;
    Tok:=Skanuj;
  else Nr_Bledu_Pars:=14; raise Blad_Parsera;
  end if;
  if Tok.Kod=Rowne then
    -- tu wpisz obsluge tokena 'Rowne'
    null;
    Tok:=Skanuj;
  else Nr_Bledu_Pars:=15; raise Blad_Parsera;
  end if;
  Wartosc;
  loop
    if not(Tok.Kod=Przecinek) then exit; end if;
    -- tu wpisz obsluge tokena 'Przecinek'
    Tok:=Skanuj;
    Wartosc;
  end loop;
  Pisz_Plik_Wy("</element>"); -- <- kod uzytkownika
end Element;

procedure Wartosc is
begin
  if Tok.Kod=Napis then
    -- wstawiony kod 
    Pisz_Plik_Wy("<wartosc>"&US(Tok.Wart)&"</wartosc>");
    -- koniec kodu 
    -- tu wpisz obsluge tokena 'Napis';
    null;
    Tok:=Skanuj;
  elsif Tok.Kod=Liczba then
    -- wstawiony kod 
    Pisz_Plik_Wy("<wartosc>"&US(Tok.Wart)&"</wartosc>");
    -- koniec kodu 
    -- tu wpisz obsluge tokena 'Liczba';
    null;
    Tok:=Skanuj;
  elsif Tok.Kod=Nazwa then
    -- wstawiony kod 
    Pisz_Plik_Wy("<wartosc>"&US(Tok.Wart)&"</wartosc>");
    -- koniec kodu 
    -- tu wpisz obsluge tokena 'Nazwa';
    null;
    Tok:=Skanuj;
  else Nr_Bledu_Pars:=16; raise Blad_Parsera;
  end if;
end Wartosc;

procedure Init_Zbiory is
begin
  Zeruj(First_Plik);
  Zeruj(First_Sekcja);
  Zeruj(First_Element);
  Zeruj(First_Wartosc);
  First_Plik := First_Plik+LewyNawiasKw;
  First_Sekcja := First_Sekcja+LewyNawiasKw;
  First_Element := First_Element+Nazwa;
  First_Wartosc := First_Wartosc+Napis+Liczba+Nazwa;
end Init_Zbiory;

end i2x_Pars;
